"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const proxyScopedSlots_1 = __importDefault(require("./proxyScopedSlots"));
function mergeListeners(a, b) {
    const map = new Map(Object.entries(a));
    b && Object.keys(b).forEach((key) => {
        if (map.has(key)) {
            map.set(key, [].concat(map.get(key)).concat(b[key]));
        }
        else {
            map.set(key, b[key]);
        }
    });
    return Object.fromEntries(map.entries());
}
function inheritComponent(baseComponent, options) {
    const instance = baseComponent;
    const componentDef = baseComponent;
    const originalProps = 'options' in instance
        ? instance.options.props
        : 'props' in componentDef
            ? componentDef.props
            : undefined;
    return {
        model: 'options' in instance
            ? instance.options.model
            : componentDef.model,
        name: options.name,
        props: {
            ...originalProps,
            ...options.props
        },
        render(h) {
            var _a, _b, _c;
            const $props = this.$props;
            const on = mergeListeners(this.$listeners, options.listeners);
            const props = (_b = (_a = options.computedProps) === null || _a === void 0 ? void 0 : _a.call(this, $props)) !== null && _b !== void 0 ? _b : $props;
            const scopedSlots = proxyScopedSlots_1.default(this);
            return h(baseComponent, {
                attrs: this.$attrs,
                class: (_c = options.computedClass) === null || _c === void 0 ? void 0 : _c.call(this, props),
                on,
                props,
                scopedSlots
            }, this.$slots.default);
        }
    };
}
exports.default = inheritComponent;
