import type { Component, ComponentOptions, DefaultProps, PropsDefinition } from 'vue/types/options';
import type { CombinedVueInstance, Vue } from 'vue/types/vue';
declare module 'vue/types/vue' {
    interface VueConstructor<V extends Vue = Vue> {
        options?: ComponentOptions<V>;
    }
}
declare type Listeners = Record<string, Function | Function[]>;
declare interface InheritComponentOptions<BaseProps, Props> {
    computedClass?: (this: typeof Vue, props: Props & BaseProps) => any;
    computedProps?: (this: typeof Vue, props: Props & BaseProps) => Props & BaseProps;
    listeners?: Listeners;
    name?: string;
    props?: PropsDefinition<Props>;
}
export default function inheritComponent<V extends Vue, BaseProps = DefaultProps, Props = DefaultProps, BaseComponent = Component<any, any, any, BaseProps>>(baseComponent: BaseComponent, options: InheritComponentOptions<BaseProps, Props>): ComponentOptions<V, any, any, any, PropsDefinition<BaseProps> & PropsDefinition<Props>> & ThisType<CombinedVueInstance<V, any, any, any, BaseProps & Props>>;
export {};
